/****************************************************************************
** $Id: qt/src/kernel/qxim.h   2.1.0   edited 2000-05-18 $
**
** Definition of QXIM class
**
** Created : 20000518
**
** Copyright (C) 2000 Mizi Research, Inc. AS.  All rights reserved.
**
** Contributor(s):
** Bumchul Kim <bumchul@mizi.com>
**
*****************************************************************************/

#ifndef NO_XIM
#ifndef QXIM_H
#define QXIM_H

#include "qt_x11.h"
#include "qlist.h"

class QXIMPreeditDrawData {
private:
	int 		qCaret;		// ?
	int			qChangeFirst;
	int			qChangeLength;

	QString		qPreeditString;		// pointer ׽Ʈ...
	QString		qResetString;

public:
	QXIMPreeditDrawData();
	~QXIMPreeditDrawData();		

	int GetCaret() {return qCaret;};	
	int GetChangeFirst() {return qChangeFirst;};	
	int GetChangeLength() {return qChangeLength;};	

	void SetPreeditString(const XIMText*, const int, const int, const int);
	QString GetPreeditString() const;

	void SetResetString(const char*);
	QString GetResetString() const;

	void Reset();
};	 					   		

class QWidget;
class QEvent;

static QList<QKeyEvent> *QKeyPressEventList;

typedef int (*QXIMProc)(XIC, XPointer, XPointer);
typedef struct {
  XPointer client_data;
  QXIMProc callback;
} QXIMCallback;

class QXIMIC {
 private:
	XIC qIC;
	QXIMPreeditDrawData *qPreeditDrawData;
	XFontSet qPreeditFontset;
	QWidget *qFocusWidget;

	QXIMIC(QWidget*, XFontSet);

	static int preedit_start_cbproc(XIC, XPointer, XPointer);
	static int preedit_draw_cbproc(XIC, XPointer, XPointer);
	static int preedit_done_cbproc(XIC, XPointer, XPointer);

 public:
	~QXIMIC();
	static QXIMIC *GetQXIC(QWidget*, XFontSet);
	QXIMPreeditDrawData *GetPreeditDrawData() {return qPreeditDrawData;}	

	void SetFocusWidget(QWidget *);
	QWidget* GetFocusWidget();
	void UnsetFocusWidget();

	XFontSet GetPreeditFont();
	void SetPreeditFont(XFontSet);

	void SetPreeditSpotLocation(unsigned long, unsigned long);
	void SetPreeditArea(int, int, int, int);

	bool IsPreeditEnable();
	void ResetIC();

	int LookupString(XKeyEvent*, QCString, KeySym*, Status*);
	bool QueueKeyPressEvent(QKeyEvent*);
	void DispatchKeyPressEvent(QWidget*); 
};

#endif  // QXIM_H
#endif	// NO_XIM
