/****************************************************************************
** $Id: qt/src/kernel/qximevent.h   2.1.0   edited 2000-08-10 $
**
** Definition of QXIMEvent class
**
** Created : 20000810
**
** Copyright (C) 2000 Mizi Research, Inc. AS.  All rights reserved.
**
** Contributor(s):
** Bumchul Kim <bumchul@mizi.com>
**
*****************************************************************************/

#ifndef NO_XIM
#ifndef QXIMEVENT_H
#define QXIMEVENT_H

#include "qevent.h"

#define QXIMDRAWEVENT 	500	
#define QXIMSTARTEVENT  501	
#define QXIMDONEEVENT   502	

class QXIMDrawEvent : public QEvent {
	int caret;
	int chg_first;
	int chg_length;
	QString string;

public:
	QXIMDrawEvent(const QString& text, int car, int fst, int len ) : 
		QEvent((QEvent::Type)QXIMDRAWEVENT),
		caret(car),
		chg_first(fst),
		chg_length(len),
		string(text)
	{ }

	int getCaret() const { return caret; }
	int getChangeFirst() const { return chg_first; } 
	int getChangeLength() const { return chg_length; }
	QString getString() const { return string; }
};

class QXIMDoneEvent : public QEvent {

public:
	QXIMDoneEvent() : QEvent((QEvent::Type)QXIMDONEEVENT)
	{ }
};	

class QXIMStartEvent : public QEvent {

public:
	QXIMStartEvent() : QEvent((QEvent::Type)QXIMSTARTEVENT)
	{ }
};	

#endif  // QXIMEVENT_H
#endif  // NO_XIM

